
From shko@top.cis.syr.edu Sat Nov  1 00:55:27 1997
Date: Sat, 1 Nov 1997 00:54:00 -0500 (EST)
From: Sung-Hoon Ko <shko@top.cis.syr.edu>
To: shko@npac.syr.edu
Subject: Forwarded mail....



---------- Forwarded message ----------
Date: Fri, 31 Oct 97 21:35:49 EST
From: bki@top
To: shko@top.cis.syr.edu

import java.net.*;
import java.io.*;
import java.util.*;

class Server implements Runnable {

  private static final int DEFAULT_PORT = 8765;
  private ServerSocket mainSock = null;
  private static Vector conVec = new Vector(5, 2); // connection vector

  public int this_port = DEFAULT_PORT;

  Thread runner;


  /**
   * constructor
   */
  public Server() {
     try {
        mainSock = new ServerSocket(this_port);
     } catch(Exception e) { 
        System.err.println("Can't create system socket, system exits."); 
        System.exit(1);
     }  
  }


  /**
   * waits for a connection then spawns a ServerManager to deal with it
   */
  public void run() {

     // continuously listen the socket
     while (true) {
        try {
           Socket this_connection = mainSock.accept();
	
           ServerManager manager = new ServerManager(this_connection, this);
           manager.start();
           conVec.addElement(manager);

           //clean up the vector if needed
           for (int i=0; i<conVec.size(); i++)
              if (!((ServerManager)(conVec.elementAt(i))).isAlive())
                  conVec.removeElementAt(i);
        } catch(Exception e) {
           System.err.println("Exception: " + e);
        }
     }
  }


  /**
   * start thread
   */   
  public void start() {
    if (runner == null); {
      runner = new Thread(this);
      runner.start();
    }
  }

  /**
   * stop thread
   */
  public void stop() {
    if (runner != null) {
      runner.stop();
      runner = null;
    }
  }


  public static void main(String[] args) {
     Server server = new Server();
     server.start();
  }

}


class ServerManager extends Thread {
   private Socket sock;
   private DataOutputStream out;
   private DataInputStream in;

   private Server parent;

   /**
    * constructor
    * @param s server socket
    */
   public ServerManager(Socket s, Server parent) {
      sock = s;
      this.parent = parent;
   }


   /**
    * read commands from the client and do work
    */
   public void run() {
      try {
	out = new DataOutputStream(sock.getOutputStream());
	in  = new DataInputStream(new BufferedInputStream(sock.getInputStream()));

        String hostname = sock.getInetAddress().getHostName();
        System.out.println("Connection from: " + hostname);
 

        doServerWork(hostname);
        sock.close();                   // close the socket

      } catch (Exception e) {
	e.printStackTrace();
      }
      stop();
   }

   ////////////////////////////////////////////////////
   // real worker
   // You need to write your codes in this function.
   // You don't need to change other parts until you know
   // know fully about all the codes.
   ///////////////////////////////////////////////////////
   private synchronized void doServerWork(String hostname) {
     try {
       System.out.println("Got from the client: " + in.readLine());
     } catch (Exception e) {
       e.printStackTrace();
     }
   }
}
